classdef PlotProperties
    %% PlotProperties holds all relevant default plot properties
    properties (SetAccess = public, GetAccess = public)

    end
    properties (SetAccess = private, GetAccess = private)
      Pfontname = 'Berthold Akzidenz Grotesk';
      Paxisequal = 0;
      Pfontsizetitle =  35;
      Pdefaultsize = [200    100   1200    800];
      Pfigurecolor = [0.80000   0.80000   0.80000];
      Paxiscolor = [1   1   1];
      Pfontcolor = [0   0   0];
      Pfontsizeaxis =  25;
      Pfontsizeaxislabel =  25;
      Pgrid =  1;
      Pxlim = [];
      Pylim = [];
      Pcaxis =  1;
      Pclim = [];
      Pclabel = '';
      Pfontsizeclabel =  25;
      Plinewidth =  2;
      %linecolor = ['#000df2','#40a6ff','#191919','#000000']
      Pcolorlist = [...
       0.00000   0.05098   0.94902;...
       0.25098   0.65098   1.00000;... 
       0.10000   0.10000   0.10000;...
       1.00000   0.00000   0.00000;...
       0.4940    0.1840    0.5560;...
       0.00000   0.50000   0.00000;...
       0.75000   0.00000   0.75000;...
       0.00000   0.75000   0.75000;...
       0.75000   0.75000   0.00000;...
       0.25000   0.25000   0.25000;...
       ];
      Pxlog = 0;
      Plinestyle = {'-','--'};
      Pfontsizelegend = 25;
      Pstemmarker = {'s','d'};
      Pcirclewidth = 1;
      Pcirclecolor = [0.1 0.1 0];
      Praywidth = 1.5;
      Praycolor = [0 0.1 0.1];
      Pfontsizecirclemarker = 20;
      PGridColor = [0 0 0];
      PGridAlpha = 0.5;
      PAreaColor = [0.56 0.8 1];

    end
    properties(Dependent)
      fontname
      axisequal
      fontsizetitle
      defaultsize
      figurecolor
      axiscolor
      fontcolor
      fontsizeaxis
      fontsizeaxislabel
      grid
      ylim
      xlim
      caxis
      clabel
      clim
      fontsizeclabel
      linewidth
      colorlist
      xlog
      linestyle
      fontsizelegend
      stemmarker
      circlewidth
      circlecolor
      raywidth
      raycolor
      fontsizecirclemarker
      GridColor
      GridAlpha
      AreaColor
    end

    
    methods
      function obj = PlotProperties( varargin ) 
      end
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      % Get Functions
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      
      function result = get.fontname(obj), result = obj.Pfontname; end
      function result = get.axisequal(obj), result = obj.Paxisequal; end
      function result = get.fontsizetitle(obj), result = obj.Pfontsizetitle; end
      function result = get.defaultsize(obj), result = obj.Pdefaultsize; end
      function result = get.figurecolor(obj), result = obj.Pfigurecolor; end
      function result = get.axiscolor(obj), result = obj.Paxiscolor; end
      function result = get.fontcolor(obj), result = obj.Pfontcolor; end
      function result = get.fontsizeaxis(obj), result = obj.Pfontsizeaxis; end
      function result = get.fontsizeaxislabel(obj), result = obj.Pfontsizeaxislabel; end
      function result = get.grid(obj), result = obj.Pgrid; end
      function result = get.ylim(obj), result = obj.Pylim; end
      function result = get.xlim(obj), result = obj.Pxlim; end
      function result = get.clim(obj), result = obj.Pclim; end
      function result = get.caxis(obj), result = obj.Pcaxis; end
      function result = get.clabel(obj), result = obj.Pclabel; end
      function result = get.fontsizeclabel(obj), result = obj.Pfontsizeclabel; end
      function result = get.linewidth(obj), result = obj.Plinewidth; end
      function result = get.colorlist(obj), result = obj.Pcolorlist; end
        
      function result = get.xlog(obj), result = obj.Pxlog; end
      function result = get.linestyle(obj), result = obj.Plinestyle; end
      function result = get.fontsizelegend(obj), result = obj.Pfontsizelegend; end
      function result = get.stemmarker(obj), result = obj.Pstemmarker; end
      function result = get.circlewidth(obj), result = obj.Pcirclewidth; end
      function result = get.circlecolor(obj), result = obj.Pcirclecolor; end
      function result = get.raywidth(obj), result = obj.Praywidth; end
      function result = get.raycolor(obj), result = obj.Praycolor; end
      function result = get.fontsizecirclemarker(obj), result = obj.Pfontsizecirclemarker; end
      function result = get.GridColor(obj), result = obj.PGridColor; end
      function result = get.GridAlpha(obj), result = obj.PGridAlpha; end
      function result = get.AreaColor(obj), result = obj.PAreaColor; end
    end
 end